; This program attempts to correct the Pilatus3 CdTe data that was collected using the wrong flat field file
; It was collected with file FF_p0_E60000_T18500_vrf_m0p100.tif, (i.e. 60 keV), but should have been collected with
; FF_p0_E37000_T18500_vrf_m0p100.tif (e.g. 37 keV)

FF_60 = read_tiff('FF_p0_E60000_T18500_vrf_m0p100.tif')
FF_37 = read_tiff('FF_p0_E37000_T18500_vrf_m0p100.tif')
FF_32 = read_tiff('ffcorr_32190_50.tif')
FF_43 = read_tiff('ffcorr_42980_50.tif')
base_file = 't_3633_0000'

data = lonarr(981, 1043, 5)

; Read 5 data files
for i=0, 4 do begin
  data[0, 0, i] = read_tiff(base_file + strtrim(i,2) + '.tif')
endfor

corrected = data

for i=0, 4 do begin
  corrected[0, 0, i] = long(data[*, *, i] / FF_60 * FF_37 + 0.5)
;  corrected[0, 0, i] = long(data[*, *, i] / FF_60 * FF_32 + 0.5)
;  corrected[0, 0, i] = long(data[*, *, i] / FF_60 * FF_43 + 0.5)
endfor

; Write out the entire corrected files
for i=0, 4 do begin
  write_tiff, base_file + strtrim(i,2) + '_corrected.tif', corrected[*, *, i], /long
endfor

; Now write 10x10 ROI from 325,460 for every image

xmin = 325
xmax = 334
ymin = 460
ymax = 469

roi = FF_60[xmin:xmax, ymin:ymax]
write_tiff, 'FF60_ROI.tif', roi, /float

roi = FF_37[xmin:xmax, ymin:ymax]
write_tiff, 'FF37_ROI.tif', roi, /float

roi = FF_32[xmin:xmax, ymin:ymax]
write_tiff, 'FF32_ROI.tif', roi, /float

roi = FF_43[xmin:xmax, ymin:ymax]
write_tiff, 'FF43_ROI.tif', roi, /float

for i=0, 4 do begin
  roi = data[xmin:xmax, ymin:ymax, i]
  write_tiff, base_file + strtrim(i,2) + '_ROI.tif', roi, /long
  roi = corrected[xmin:xmax, ymin:ymax, i]
  write_tiff, base_file + strtrim(i,2) + '_ROI_corrected.tif', roi, /long
endfor

end


